unit Step_b;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,CheckLst, 
   lib , gv;

type
  TFStep = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Memo2: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure ReadS;
  procedure mInc(b:boolean;clb: TCheckListBox; var n:integer);
  procedure mDec(b:boolean;clb: TCheckListBox; var n:integer);
  procedure SetTop(Cu:integer; c_lb: TCheckListBox);

var
  FStep: TFStep;
  EStyle : TmyStyle;
  RStyle : TmyStyle;
  Mody   : boolean;

implementation

uses show;

{$R *.dfm}

procedure SetTop(Cu:integer; c_lb: TCheckListBox);
begin
  with c_lb do
   begin
    TopIndex := Cu-1;
    ItemIndex := Cu;
   end;
end;

procedure Read_Str(Cu:integer; c_lb: TCheckListBox; Me:TMemo; var LStyle : TmyStyle);
begin
 with FStep do
 begin
  Me.Clear;
  with c_lb do
   begin
    TopIndex := Cu-1;
    ItemIndex := Cu;
    Me.Lines.Add(GetStyle(Items[Cu], LStyle));
    Me.Modified := false;
   end;
 end;
end;

procedure ReadS;
begin
 with FStep do
 begin
  Read_Str(CurE,  EBook.LBcon, Memo1, EStyle);
  Read_Str(CurR,  RBook.LBcon, Memo2, RStyle);
 end;
end;

procedure SaveMemo(clb: TCheckListBox; Me:TMemo; Sy : TmyStyle; n:integer);
var
 i : integer;
begin
 Mody := true;
    clb.Items.Delete(n);
    for i := 0 to Me.Lines.Count - 1 do
      begin
       clb.Items.Insert(n, SetStyle1(Sy)+Me.Lines[i]);
       inc(n);
      end;
end;

procedure mInc(b:boolean;clb: TCheckListBox; var n:integer);
var
 m : integer;
begin
   m := n + 1;
 if b then while clb.Checked[m] do inc(m);
 if m < clb.Count then n := m;
end;


procedure myInc(b:boolean;clb: TCheckListBox; Me:TMemo; Sy : TmyStyle; var n:integer);
begin
 if Me.Modified then
    SaveMemo(clb, Me, Sy, n);
 mInc(b,clb, n);
end;

procedure mDec(b:boolean;clb: TCheckListBox; var n:integer);
var
 m : integer;
begin
 m := n - 1;
 if b then while clb.Checked[m] do dec(m);
 if m > -1 then n := m;
end;

procedure myDec(b:boolean;clb: TCheckListBox; Me:TMemo; Sy : TmyStyle; var n:integer);
begin
 if Me.Modified then
    SaveMemo(clb, Me, Sy, n);
 mDec(b, clb, n);
end;

procedure TFStep.Button1Click(Sender: TObject);
begin
  myDec(true, EBook.LBcon,  memo1, EStyle,  CurE);
  myDec(true, RBook.LBcon, memo2, RStyle,  CurR);
  ReadS;
  if Form2.Visible then
   begin
     mShow;
   end;
end;
procedure TFStep.Button2Click(Sender: TObject);
begin  // next
  myInc(true, EBook.LBcon, memo1, EStyle, CurE);
  myInc(true, RBook.LBcon, Memo2, RStyle, CurR);
  ReadS;
  if Form2.Visible then
   begin
     mShow;
   end;
end;

procedure TFStep.Button4Click(Sender: TObject);
begin
  myInc(false, RBook.LBcon, Memo2, RStyle, CurR);
  Read_Str(CurR,  RBook.LBcon, Memo2, RStyle);
end;
                                      
procedure TFStep.Button3Click(Sender: TObject);
begin
  myDec(true, RBook.LBcon, memo2, RStyle,  CurR);
  Read_Str(CurR,  RBook.LBcon, Memo2, RStyle);
end;

end.
