unit lib;

interface
uses
 Classes, SysUtils, Dialogs, gv, dm;

  function GetStyle(S:string; var m:TmyStyle):string;
  function GetStr(S:string):string;
  function SetStyle1(n:TmyStyle):AnsiString;
  function GetLevel(LStyle : TmyStyle):byte;
  function SetStyle(n:TmyStyle):AnsiString;

  function GetGaner(S:AnsiString):AnsiString;  

implementation

function GetStyle(S:string; var m:TmyStyle):string;
var
 n : byte;
 ss : string;
begin
   n := pos('|', S);
   ss := copy(s,1,n-1); // 
    case ss[length(ss)] of
     'N' : m := Norm;
     'E' : m := Epig;
     'A' : m := Auth;
     'Z' : m := Title;
     '0' : m := H0;
     '1' : m := H1;
     '2' : m := H2;
     '3' : m := H3;
     '4' : m := H4;
     '5' : m := H5;
     '6' : m := H6;
     '7' : m := H7;
     'S' : m := Sub;
     'P' : m := Poem;
     'C' : m := Citat;
     'i' : m := Image;   // 13.07.11
     't' : m := Table;
     '-' : m := None;
    end;// case
   delete(s,1,n+1);      // 
   result := S;
end;

function GetLevel(LStyle : TmyStyle):byte;
begin
     case LStyle of
       H1 : result := 1;
       H2 : result := 2;
       H3 : result := 3;
       H4 : result := 4;
       H5 : result := 5;
       H6 : result := 6;
       H7 : result := 7;
       H8 : result := 8;
       H9 : result := 9;
       H10 : result := 10;
       else result := 0;
       end; // case
end;

function SetStyle(n:TmyStyle):AnsiString;
begin
 case n of
   Norm : result  := ' N';
   Epig : result  := ' E';
   Auth : result  := ' A';
   Title: result  := ' Z';
   H1 : result    := 'H1';
   H2 : result    := 'H2';
   H3 : result    := 'H3';
   H4 : result    := 'H4';
   H5 : result    := 'H5';
   H6 : result    := 'H6';
   H7 : result    := 'H7';
   H8 : result    := 'H8';
   H9 : result    := 'H9';
   Sub : result   := ' S';
   Poem : result  := ' P';
   Citat : result := ' C';
   None  : result := '--';
 end; // case
end;

function SetStyle1(n:TmyStyle):AnsiString;
begin
 result := ' '+ SetStyle(n)+'| ';
end;


function GetStr(S:string):string;
var
 n : byte;
begin        //******
   n := pos('|', S);
   delete(s,1,n+1);      // 
   result := S;
end;

function GetGaner(S:AnsiString):AnsiString;
var
 i : integer;
begin
 for i := 0 to maxg do
  if gg[i][2] = S then
    begin
     result := gg[i][1];
     exit;
    end;
 result := s;    
end;

END.
